searchNodes=[{"doc":"This is the main Machinery module. It keeps most of the Machinery logics, it's the module that will be imported with use on the module responsible for the state machine. Declare the states as an argument when importing Machinery on the module that will control your states transitions. Machinery expects a Keyword as argument with two keys states and transitions . Parameters opts : A Keyword including states and transitions . states : A List of Machinery.Transition.state/0 representing each state. transitions : A Map for each state and it allowed next state(s). Example defmodule YourProject.UserStateMachine do use Machinery , # The first state declared will be considered # the intial state states : [ &quot;created&quot; , &quot;partial&quot; , &quot;complete&quot; ] , transitions : %{ &quot;created&quot; =&gt; [ &quot;partial&quot; , &quot;complete&quot; ] , &quot;partial&quot; =&gt; &quot;completed&quot; } end","ref":"Machinery.html","title":"Machinery","type":"module"},{"doc":"Main macro function that will be executed upon the load of the module using it. It basically stores the states and transitions. It expects a Keyword as argument with two keys states and transitions . states : A List of Machinery.Transition.state/0 representing each state. transitions : A Map for each state and it allowed next state(s). P.S. The first state declared will be considered the initial state","ref":"Machinery.html#__using__/1","title":"Machinery.__using__/1","type":"macro"},{"doc":"Start function that will trigger a supervisor for the Machinery.Transitions, a GenServer that controls the state transitions.","ref":"Machinery.html#start/2","title":"Machinery.start/2","type":"function"},{"doc":"Triggers the transition of a struct to a new state, accordingly to a specific state machine module, if it passes any existing guard functions. It also runs any before or after callbacks and returns a tuple with {:ok, struct} , or {:error, &quot;reason&quot;} . Parameters struct : The struct you want to transit to another state. state_machine_module : The module that holds the state machine logic, where Machinery as imported. next_state : Machinery.Transition.state/0 of the next state you want to transition to. extra_metadata (optional): Map with extra data you might want to access in any of the Machinery functions (callbacks, guard, log, persist). Examples Machinery . transition_to ( % User { state : :partial } , UserStateMachine , &quot;completed&quot; ) { :ok , % User { state : &quot;completed&quot; } } # Or Machinery . transition_to ( % User { state : :partial } , UserStateMachine , &quot;completed&quot; , %{ verified : true } ) { :ok , % User { state : &quot;completed&quot; } }","ref":"Machinery.html#transition_to/4","title":"Machinery.transition_to/4","type":"function"},{"doc":"Machinery module responsible for control transitions, guard functions and callbacks (before and after). This is meant to be for internal use only.","ref":"Machinery.Transition.html","title":"Machinery.Transition","type":"module"},{"doc":"Function responsible to run all after_transitions callbacks or fallback to a boilerplate behaviour. This is meant to be for internal use only.","ref":"Machinery.Transition.html#after_callbacks/4","title":"Machinery.Transition.after_callbacks/4","type":"function"},{"doc":"Function responsible to run all before_transitions callbacks or fallback to a boilerplate behaviour. This is meant to be for internal use only.","ref":"Machinery.Transition.html#before_callbacks/4","title":"Machinery.Transition.before_callbacks/4","type":"function"},{"doc":"Function responsible for checking if the transition from a state to another was specifically declared. This is meant to be for internal use only.","ref":"Machinery.Transition.html#declared_transition?/3","title":"Machinery.Transition.declared_transition?/3","type":"function"},{"doc":"Default guard transition fallback to make sure all transitions are permitted unless another existing guard condition exists. This is meant to be for internal use only.","ref":"Machinery.Transition.html#guarded_transition?/4","title":"Machinery.Transition.guarded_transition?/4","type":"function"},{"doc":"Function responsible for triggering transitions persistence. This is meant to be for internal use only.","ref":"Machinery.Transition.html#log_transition/4","title":"Machinery.Transition.log_transition/4","type":"function"},{"doc":"This function will try to trigger persistence, if declared, to the struct changing state. This is meant to be for internal use only.","ref":"Machinery.Transition.html#persist_struct/4","title":"Machinery.Transition.persist_struct/4","type":"function"},{"doc":"A state should be a string or an atom. Whichever corresponds with the underlying state field on the given struct.","ref":"Machinery.Transition.html#t:state/0","title":"Machinery.Transition.state/0","type":"type"},{"doc":"This is a GenServer that controls the transitions for a struct using a set of helper functions from Machinery.Transition It's meant to be run by a supervisor.","ref":"Machinery.Transitions.html","title":"Machinery.Transitions","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Machinery.Transitions.html#child_spec/1","title":"Machinery.Transitions.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Machinery.Transitions.html#init/1","title":"Machinery.Transitions.init/1","type":"function"},{"doc":"ChangeLog","ref":"changelog.html","title":"ChangeLog","type":"extras"},{"doc":"","ref":"changelog.html#wip-version","title":"ChangeLog - WIP Version","type":"extras"},{"doc":"Adding extra metadata support for transitions - Pull Request","ref":"changelog.html#1-1-0","title":"ChangeLog - 1.1.0","type":"extras"},{"doc":"Fixing overall TYPOs Pull Request#1 Pull Request#2 Pull Request#3 Pull Request#4 Pull Request#5 Delegate json_decoder config to phoenix - Pull Request Fixing flaky tests - Pull Request Remove Pheonix dependency (and dashboard feature) - Pull Request Resolve Machinery GenServer Get Timeout - Pull Request","ref":"changelog.html#1-0-0","title":"ChangeLog - 1.0.0","type":"extras"},{"doc":"Allow field name customization - Pull Request","ref":"changelog.html#0-17-0","title":"ChangeLog - 0.17.0","type":"extras"},{"doc":"Bumping Ecto version - Pull Request","ref":"changelog.html#0-16-1","title":"ChangeLog - 0.16.1","type":"extras"},{"doc":"Support for custom error messages on guard functions - Pull Request","ref":"changelog.html#0-16-0","title":"ChangeLog - 0.16.0","type":"extras"},{"doc":"Adding support for transitions logging - Pull Request","ref":"changelog.html#0-15-0","title":"ChangeLog - 0.15.0","type":"extras"},{"doc":"Adding support for wildcard transitions - Pull Request","ref":"changelog.html#0-14-0","title":"ChangeLog - 0.14.0","type":"extras"},{"doc":"Adding basic auth to Machinery Dashboard - Pull Request","ref":"changelog.html#0-13-0","title":"ChangeLog - 0.13.0","type":"extras"},{"doc":"Better treating the JSON return for the Dashboard - Pull Request","ref":"changelog.html#0-12-1","title":"ChangeLog - 0.12.1","type":"extras"},{"doc":"Adding new toogle all btn and auto closing alerts - Pull Request Fixing Bug to rollback state transition on the Dashboard - Pull Request","ref":"changelog.html#0-12-0","title":"ChangeLog - 0.12.0","type":"extras"},{"doc":"Adding a default config desabling the Machinery Dashboard Making the Machinery Dashboard bigger Enabling users to overwrite the desired state on Machinery Dashboard - Pull Request Adding the ability to change states form Dashboard - Pull Request","ref":"changelog.html#0-11-0","title":"ChangeLog - 0.11.0","type":"extras"},{"doc":"Requiring a previous version of phoenix_html to enable older applications to use Machinery. Versioning compiled version of the assets to fix bug on dashboard interface.","ref":"changelog.html#0-8-2","title":"ChangeLog - 0.8.2","type":"extras"},{"doc":"Adding first version of Machinery Dashboard - Pull Request","ref":"changelog.html#0-8-0","title":"ChangeLog - 0.8.0","type":"extras"},{"doc":"Improving docs Updating DSl to Decouple Machinery from the struct itself - Pull Request Adding support for automatic persistence - Pull Request Converting states from Atoms to Strings - Pull Request","ref":"changelog.html#0-7-0","title":"ChangeLog - 0.7.0","type":"extras"},{"doc":"Updating wrong docs and README - Pull Request","ref":"changelog.html#0-4-1","title":"ChangeLog - 0.4.1","type":"extras"},{"doc":"New, more functional DSL, not relying on Macros so much - Pull Request Adding support for before and after callbacks - Pull Request","ref":"changelog.html#0-4-0","title":"ChangeLog - 0.4.0","type":"extras"},{"doc":"Enabling states and transitions declarations Adding support for guard functions","ref":"changelog.html#0-2-0","title":"ChangeLog - 0.2.0","type":"extras"},{"doc":"Contributing If you want to help Machinery development we recommend you to start by checking its existing Issues . You may also want to start with something small like updating docs or the README.","ref":"contributing.html","title":"Contributing","type":"extras"},{"doc":"If you have a feature you would like to see implemented, before jumping into the code, it's highly recommended that you open an issue describing your reasons, benefits and drawbacks. That way, we as a community can check your proposal and give you some feedback, that is extremelly helpful to achieve better ideas and also keeps you of doing code that might not be approved because of many reasons.","ref":"contributing.html#feature-proposal","title":"Contributing - Feature proposal","type":"extras"},{"doc":"Bugs should also be reported through issues, that sould contain how to replicate the bug and some trace of the error.","ref":"contributing.html#bug-report","title":"Contributing - Bug Report","type":"extras"},{"doc":"Contributor Covenant Code of Conduct","ref":"code_of_conduct.html","title":"Code of Conduct","type":"extras"},{"doc":"In the interest of fostering an open and welcoming environment, we as contributors and maintainers pledge to making participation in our project and our community a harassment-free experience for everyone, regardless of age, body size, disability, ethnicity, gender identity and expression, level of experience, nationality, personal appearance, race, religion, or sexual identity and orientation.","ref":"code_of_conduct.html#our-pledge","title":"Code of Conduct - Our Pledge","type":"extras"},{"doc":"Examples of behavior that contributes to creating a positive environment include: Using welcoming and inclusive language Being respectful of differing viewpoints and experiences Gracefully accepting constructive criticism Focusing on what is best for the community Showing empathy towards other community members Examples of unacceptable behavior by participants include: The use of sexualized language or imagery and unwelcome sexual attention or advances Trolling, insulting/derogatory comments, and personal or political attacks Public or private harassment Publishing others' private information, such as a physical or electronic address, without explicit permission Other conduct which could reasonably be considered inappropriate in a professional setting","ref":"code_of_conduct.html#our-standards","title":"Code of Conduct - Our Standards","type":"extras"},{"doc":"Project maintainers are responsible for clarifying the standards of acceptable behavior and are expected to take appropriate and fair corrective action in response to any instances of unacceptable behavior. Project maintainers have the right and responsibility to remove, edit, or reject comments, commits, code, wiki edits, issues, and other contributions that are not aligned to this Code of Conduct, or to ban temporarily or permanently any contributor for other behaviors that they deem inappropriate, threatening, offensive, or harmful.","ref":"code_of_conduct.html#our-responsibilities","title":"Code of Conduct - Our Responsibilities","type":"extras"},{"doc":"This Code of Conduct applies both within project spaces and in public spaces when an individual is representing the project or its community. Examples of representing a project or community include using an official project e-mail address, posting via an official social media account, or acting as an appointed representative at an online or offline event. Representation of a project may be further defined and clarified by project maintainers.","ref":"code_of_conduct.html#scope","title":"Code of Conduct - Scope","type":"extras"},{"doc":"Instances of abusive, harassing, or otherwise unacceptable behavior may be reported by contacting the project team at me@joaomdmoura.com. The project team will review and investigate all complaints, and will respond in a way that it deems appropriate to the circumstances. The project team is obligated to maintain confidentiality with regard to the reporter of an incident. Further details of specific enforcement policies may be posted separately. Project maintainers who do not follow or enforce the Code of Conduct in good faith may face temporary or permanent repercussions as determined by other members of the project's leadership.","ref":"code_of_conduct.html#enforcement","title":"Code of Conduct - Enforcement","type":"extras"},{"doc":"This Code of Conduct is adapted from the Contributor Covenant , version 1.4, available at http://contributor-covenant.org/version/1/4","ref":"code_of_conduct.html#attribution","title":"Code of Conduct - Attribution","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS","ref":"license.html","title":"License","type":"extras"},{"doc":"Machinery Machinery is a lightweight State Machine library for Elixir with built-in Phoenix integration. It provides a simple DSL for declaring states and includes support for guard clauses and callbacks.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Installing Declaring States Changing States Persist State Logging Transitions Guard Functions Before and After Callbacks","ref":"readme.html#table-of-contents","title":"Overview - Table of Contents","type":"extras"},{"doc":"Add :machinery to your list of dependencies in mix.exs : def deps do [ { :machinery , &quot;~&gt; 1.1.0&quot; } ] end Create a state field (or a custom name) for the module you want to apply a state machine to, and ensure it's declared as part of your defstruct. If using a Phoenix model, add it to the schema as a string and include it in the changeset/2 function: defmodule YourProject.User do schema &quot;users&quot; do # ... field :state , :string # ... end def changeset ( % User { } = user , attrs ) do #... |&gt; cast ( attrs , [ :state ] ) #... end end","ref":"readme.html#installing","title":"Overview - Installing","type":"extras"},{"doc":"Create a separate module for your State Machine logic. For example, if you want to add a state machine to your User model, create a UserStateMachine module. Then import Machinery in this new module and declare states as arguments. Machinery expects a Keyword as an argument with the keys field , states and transitions . field : An atom representing your state field name (defaults to state ) states : A List of Machinery.Transition.state/0 s representing each state. transitions : A Map for each state and its allowed next state(s). Example defmodule YourProject.UserStateMachine do use Machinery , field : :custom_state_name , # Optional, default value is `:field` states : [ &quot;created&quot; , &quot;partial&quot; , &quot;completed&quot; , &quot;canceled&quot; ] , transitions : %{ &quot;created&quot; =&gt; [ &quot;partial&quot; , &quot;completed&quot; ] , &quot;partial&quot; =&gt; &quot;completed&quot; , &quot;*&quot; =&gt; &quot;canceled&quot; } end You can use wildcards &quot;*&quot; to declare a transition that can happen from any state to a specific one.","ref":"readme.html#declaring-states","title":"Overview - Declaring States","type":"extras"},{"doc":"To transition a struct to another state, call Machinery.transition_to/3 or Machinery.transition_to/4 . Machinery.transition_to/3 or `Machinery.transition_to/4 It takes the following arguments: struct : The struct you want to transition to another state. state_machine_module : The module that holds the state machine logic, where Machinery is imported. next_event : Machinery.Transition.state/0 of the next state you want the struct to transition to. (optional) extra_metadata : map with any extra data you might want to access on any of the sate machine functions triggered by the state change Machinery . transition_to ( your_struct , YourStateMachine , &quot;next_state&quot; ) # {:ok, updated_struct} # OR Machinery . transition_to ( your_struct , YourStateMachine , &quot;next_state&quot; , %{ extra : &quot;metadata&quot; } ) # {:ok, updated_struct} Example user = Accounts . get_user! ( 1 ) { :ok , updated_user } = Machinery . transition_to ( user , UserStateMachine , &quot;completed&quot; )","ref":"readme.html#changing-states","title":"Overview - Changing States","type":"extras"},{"doc":"To persist the struct and state transition, you declare a persist/2 or /3 (in case you wanna access metadata passed on transition_to/4 ) function in the state machine module. This function will receive the unchanged struct as the first argument and a Machinery.Transition.state/0 of the next state as the second one. your persist/2 or persist/3 should always return the updated struct. Note on atom() states and persistence You may need to deal with deserializing your states if working with atom/0 Machinery.Transition.state/0 s and Ecto as atom/0 s will be stored in the database as String.t/0 s. If you aren't using persistence, this won't be a problem. Example defmodule YourProject.UserStateMachine do alias YourProject.Accounts use Machinery , states : [ &quot;created&quot; , &quot;completed&quot; ] , transitions : %{ &quot;created&quot; =&gt; &quot;completed&quot; } # You can add an optional third argument for the extra metadata. def persist ( struct , next_state ) do # Updating a user on the database with the new state. { :ok , user } = Accounts . update_user ( struct , %{ state : next_stated } ) # `persist` should always return the updated struct user end end","ref":"readme.html#persist-state","title":"Overview - Persist State","type":"extras"},{"doc":"To log transitions, Machinery provides a log_transition/2 or /3 (in case you wanna access metadata passed on transition_to/4 ) callback that is called on every transition, after the persist function is executed. This function receives the unchanged struct as the first argument and a Machinery.Transition.state/0 of the next state as the second one. log_transition/2 or log_transition/3 should always return the struct. Example defmodule YourProject.UserStateMachine do alias YourProject.Accounts use Machinery , states : [ &quot;created&quot; , &quot;completed&quot; ] , transitions : %{ &quot;created&quot; =&gt; &quot;completed&quot; } # You can add an optional third argument for the extra metadata. def log_transition ( struct , _next_state ) do # Log transition here. # ... # `log_transition` should always return the struct struct end end","ref":"readme.html#logging-transitions","title":"Overview - Logging Transitions","type":"extras"},{"doc":"Create guard conditions by adding guard_transition/2 or /3 (in case you wanna access metadata passed on transition_to/4 ) function signatures to the state machine module. This function receives two arguments: the struct and a Machinery.Transition.state/0 of the state it will transition to. Use the second argument for pattern matching the desired state you want to guard. # The second argument is used to pattern match into the state # and guard the transition to it. # # You can add an optional third argument for the extra metadata. def guard_transition ( struct , &quot;guarded_state&quot; ) do # Your guard logic here end Guard conditions will allow the transition if it returns anything other than a tuple with {:error, &quot;cause&quot;} : {:error, &quot;cause&quot;} : Transition won't be allowed. _ (anything else) : Guard clause will allow the transition. Example defmodule YourProject.UserStateMachine do use Machinery , states : [ &quot;created&quot; , &quot;completed&quot; ] , transitions : %{ &quot;created&quot; =&gt; &quot;completed&quot; } # Guard the transition to the &quot;completed&quot; state. def guard_transition ( struct , &quot;completed&quot; ) do if Map . get ( struct , :missing_fields ) == true do { :error , &quot;There are missing fields&quot; } end end end When trying to transition a struct that is blocked by its guard clause, you will have the following return: blocked_struct = % TestStruct { state : &quot;created&quot; , missing_fields : true } Machinery . transition_to ( blocked_struct , TestStateMachineWithGuard , &quot;completed&quot; ) # {:error, &quot;There are missing fields&quot;}","ref":"readme.html#guard-functions","title":"Overview - Guard functions","type":"extras"},{"doc":"You can also use before and after callbacks to handle desired side effects and reactions to a specific state transition. You can declare before_transition/2 or /3 (in case you wanna access metadata passed on transition_to/4 ) and after_transition/2 or /3 (in case you wanna access metadata passed on transition_to/4 ) , pattern matching the desired state you want to. Before and After callbacks should return the struct. # Before and After callbacks should return the struct. # You can add an optional third argument for the extra metadata. def before_transition ( struct , &quot;state&quot; ) , do : struct def after_transition ( struct , &quot;state&quot; ) , do : struct Example defmodule YourProject.UserStateMachine do use Machinery , states : [ &quot;created&quot; , &quot;partial&quot; , &quot;completed&quot; ] , transitions : %{ &quot;created&quot; =&gt; [ &quot;partial&quot; , &quot;completed&quot; ] , &quot;partial&quot; =&gt; &quot;completed&quot; } def before_transition ( struct , &quot;partial&quot; ) do # ... overall desired side effects struct end def after_transition ( struct , &quot;completed&quot; ) do # ... overall desired side effects struct end end","ref":"readme.html#before-and-after-callbacks","title":"Overview - Before and After callbacks","type":"extras"},{"doc":"Copyright (c) 2016 João M. D. Moura Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#copyright-and-license","title":"Overview - Copyright and License","type":"extras"}]